#include "io.h"
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#define BAUD 19200

#define CS	PB2
#define DAT	PB3
#define CLK	PB5
#define UCRST	PB0

void avr_initio(void) {
    //init spi
    DDRC=3;
    PORTC=1;
    SPCR=0xC0;
    DDRB=(1<<CS)+(1<<DAT)+(1<<CLK);
    //init uart
    UCSR0B=0xB8;
    UBRR0=64;
}

void setmode(char m) {
    if (m==1) {
	DDRB|=(1<<UCRST);
	SPCR&=~0x40;
	DDRB=(1<<CS)+(1<<DAT)+(1<<CLK);
    } else {
	DDRB&=~(1<<UCRST);
	SPCR|=0x40;
    }
}

void raisecs() {
    PORTB|=(1<<CS);
}

void bangnibble(char n){
    char t;
    if (PORTB|(1<<CS)) {
	PORTB&=~(1<<CS);
	_delay_us(150);
    }
    for (t=0; t<4; t++) {
	if (n&8) PORTB|=(1<<DAT); else PORTB&=~(1<<DAT);
	PORTB&=~(1<<CLK);
	_delay_us(2);
	PORTB|=(1<<CLK);
	_delay_us(2);
	n<<=1;
    }
    PORTB&=~(1<<CLK);
}
